// -*- mode: C++; -*-

/* LibGM: A Geometrical Library
 * Copyright (C) 1997-1998 Marcelo de G. Malheiros
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef GM_CONST_H
#define GM_CONST_H

// useful constants

double const GM_2PI =       6.28318530717958623200;
double const GM_DEGTORAD =  0.01745329251994329547;
double const GM_E =         2.71828182845904553488;
double const GM_EEXPPI =   23.14069263277927390732;
double const GM_GOLDEN =    1.61803398874989490253;
double const GM_INVPI =     0.31830988618379069122;
double const GM_LN10 =      2.30258509299404590109;
double const GM_LN2 =       0.69314718055994528623;
double const GM_LOG10E =    0.43429448190325187218;
double const GM_LOG2E =     1.44269504088896338700;
double const GM_PI =        3.14159265358979323846;
double const GM_PIDIV2 =    1.57079632679489655800;
double const GM_PIDIV4 =    0.78539816339744827900;
double const GM_RADTODEG = 57.29577951308232286465;
double const GM_SQRT2 =     1.41421356237309514547;
double const GM_SQRT2PI =   2.50662827463100024161;
double const GM_SQRT3 =     1.73205080756887719318;
double const GM_SQRT10 =    3.16227766016837952279;
double const GM_SQRTE =     1.64872127070012819416;
double const GM_SQRTHALF =  0.70710678118654757274;
double const GM_SQRTLN2 =   0.83255461115769768821;
double const GM_SQRTPI =    1.77245385090551588192;
double const GM_EPSILON =   1.0e-10;
double const GM_EPSILON2 =  1.0e-20;
double const GM_GOOGOL =    1.0e50;


#endif // GM_CONST_H
