#include <GL/glut.h>

#include "mtk.h"

float n[6][3] = {
  {-1.0, 0.0, 0.0}, {0.0, 1.0, 0.0}, {1.0, 0.0, 0.0},
  {0.0, -1.0, 0.0}, {0.0, 0.0, -1.0}, {0.0, 0.0, 1.0}
};

int faces[6][4] = {
  {0, 3, 2, 1}, {2, 3, 7, 6}, {4, 5, 6, 7},
  {0, 1, 5, 4}, {1, 2, 6, 5}, {0, 4, 7, 3}
};

float v[8][3];
mtkCoreGL *core;
mtkCameraId cid;


void reshape (int w, int h)
{
  core->cameraResize(cid, 0, 0, w, h);
}


void display (void)
{
  core->cameraDraw(cid);
  glutSwapBuffers();
}


void keyboard (unsigned char key, int x, int y)
{
  // unused parameters
  x=y;

  switch (key) {
  case 27:
    exit(0);
  default:
    break;
  }
}


void init (void)
{
  core=new mtkCoreGL();
  cid=core->createCamera();
  core->cameraInitialize(cid);
  core->setCameraPosition(cid, 1.5, -2.5, 5.0, MTK_ABSOLUTE);

  v[0][0] = v[1][0] = v[2][0] = v[3][0] = -1.0;
  v[4][0] = v[5][0] = v[6][0] = v[7][0] =  1.0;
  v[0][1] = v[1][1] = v[4][1] = v[5][1] = -1.0;
  v[2][1] = v[3][1] = v[6][1] = v[7][1] =  1.0;
  v[0][2] = v[3][2] = v[4][2] = v[7][2] =  1.0;
  v[1][2] = v[2][2] = v[5][2] = v[6][2] = -1.0;

  core->createElement(1);
  for (int i=0; i<6; i++) {
    core->begin(MTK_POLYGON);
    core->setNormal(n[i][0], n[i][1], n[i][2]);
    core->setVertex(v[faces[i][0]][0], v[faces[i][0]][1], v[faces[i][0]][2]);
    core->setVertex(v[faces[i][1]][0], v[faces[i][1]][1], v[faces[i][1]][2]);
    core->setVertex(v[faces[i][2]][0], v[faces[i][2]][1], v[faces[i][2]][2]);
    core->setVertex(v[faces[i][3]][0], v[faces[i][3]][1], v[faces[i][3]][2]);
    core->end();
  }
  core->finishElement();

  core->setLightType(MTK_LIGHT0, MTK_DIRECTIONAL_LIGHT);
  core->setLightPosition(MTK_LIGHT0, gmPoint3(1.0, 1.0, 1.0));
  core->setLightComponents(MTK_LIGHT0, MTK_DIFFUSE,
                           gmPoint4(1.0, 0.0, 0.0, 1.0));
  core->setLight(MTK_LIGHT0, MTK_ACTIVE);
  core->setLighting(MTK_ACTIVE);
}


int main (int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutCreateWindow("red cube -- MTK");

  glutReshapeFunc(reshape);
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);

  init();
  glutMainLoop();
  return 0;
}
