#include <GL/glut.h>

GLfloat n[6][3] = {
  {-1.0, 0.0, 0.0}, {0.0, 1.0, 0.0}, {1.0, 0.0, 0.0},
  {0.0, -1.0, 0.0}, {0.0, 0.0, -1.0}, {0.0, 0.0, 1.0}
};

int faces[6][4] = {
  {0, 3, 2, 1}, {2, 3, 7, 6}, {4, 5, 6, 7},
  {0, 1, 5, 4}, {1, 2, 6, 5}, {0, 4, 7, 3}
};

GLfloat v[8][3];
GLfloat light_diffuse[] = {1.0, 0.0, 0.0, 1.0};
GLfloat light_position[] = {1.0, 1.0, 1.0, 0.0};


void reshape (int w, int h)
{
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0, (GLdouble)w/h, 0.5, 100.0);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(1.5, -2.5, 5.0,
            0.0, 0.0, 0.0,
            0.0, 1.0, 0.0);

  glViewport(0, 0, w, h);
}


void display (void)
{
  int i;

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  for (i = 0; i < 6; i++) {
    glBegin(GL_POLYGON);
    glNormal3fv(&n[i][0]);
    glVertex3fv(&v[faces[i][0]][0]);
    glVertex3fv(&v[faces[i][1]][0]);
    glVertex3fv(&v[faces[i][2]][0]);
    glVertex3fv(&v[faces[i][3]][0]);
    glEnd();
  }
  glutSwapBuffers();
}


void keyboard (unsigned char key, int x, int y)
{
  // unused parameters
  x=y;

  switch (key) {
  case 27:
    exit(0);
  default:
    break;
  }
}


void init (void)
{
  v[0][0] = v[1][0] = v[2][0] = v[3][0] = -1.0;
  v[4][0] = v[5][0] = v[6][0] = v[7][0] =  1.0;
  v[0][1] = v[1][1] = v[4][1] = v[5][1] = -1.0;
  v[2][1] = v[3][1] = v[6][1] = v[7][1] =  1.0;
  v[0][2] = v[3][2] = v[4][2] = v[7][2] =  1.0;
  v[1][2] = v[2][2] = v[5][2] = v[6][2] = -1.0;

  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);

  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_PROJECTION);
  gluPerspective(45.0, 1.0, 1.0, 10.0);

  glMatrixMode(GL_MODELVIEW);
  gluLookAt(1.5, -2.5, 5.0,
            0.0, 0.0, 0.0,
            0.0, 1.0, 0.0);
}


int main (int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutCreateWindow("red cube -- OpenGL");

  glutReshapeFunc(reshape);
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);

  init();
  glutMainLoop();
  return 0;
}
