
#include <stdio.h>
#include <math.h>
#include <time.h>

#include "gm.h"
#include "mtk.h"
#include "mtk_manip.h"
#include "../mtkx.h"
#include <GL/glu.h>

mtkCoreGL *core;
mtkCameraId cid;

GLdouble xlimit = 2, zlimit =3;

mtkxGlutWindow *janela;

double rnd(int x)
{
   return ((double)x*(double)rand()/(RAND_MAX+1.0));
}

void update ();

GLdouble func(GLdouble x, GLdouble z)
{
   GLdouble d = 4-x*x-z*z;
   if(d < 0)
      return 0;
   else
      return sqrt(d);

/*   x = x;
   return sin(z);*/
}

GLdouble dfuncz(GLdouble x, GLdouble z)
{
   return -z;
}

void MapaSeno(gmPoint3 p, int x, int y, gmPoint3 &result)
{
   static GLdouble acoef = -1;
   GLdouble coef;
   
   mtkxWindow::_mtkxMappingPlanes(p,x,y,result);

   p = core->getCursorPosition();
   coef = func(result[0],result[2])-result[1];


   if(result[0] >= -xlimit && result[0] <= xlimit 
      && result[2] >= -zlimit && result[2] <= zlimit
      && coef*acoef <= 0)
   {
      if(result[2] != p[2])
         result[1] = coef+result[1];
      else
      {
         if(dfuncz(result[0],result[2]) <= 0)
            result[2] = p[2]-(result[1]-p[1]);
         else
            result[2] = p[2]+(result[1]-p[1]);

         result[1] = func(result[0],result[2]);
      }
   }
   else
      if(coef != 0)
         acoef = coef;

}


void keyboard (unsigned char key, int x, int y)
{
  // unused parameters
  x=y;

  switch (key) {
  case 27:
    exit(0);
  default:
    break;
  }
}


void update ()
{
  GLdouble z,dz, x, dx;

  core->setLightType(MTK_LIGHT0, MTK_DIRECTIONAL_LIGHT);
  core->setLightPosition(MTK_LIGHT0, gmPoint3(2.2, 4.0, 2.8));
  core->setLightComponents(MTK_LIGHT0, MTK_DIFFUSE,
                           gmPoint4(1.0, 1.0, 1.0, 1.0));
  core->setLight(MTK_LIGHT0, MTK_ACTIVE);
  core->setLighting(MTK_ACTIVE);


  core->setMaterialv(MTK_FRONT,MTK_DIFFUSE,
                     gmPoint4(0.0, 1.0, 1.0, 1.0));
  core->createElement(1);
  dz = 0.4;
  dx = 0.4;

  for(z=-zlimit; z < zlimit; z += dz)
  for(x=-xlimit; x < xlimit; x += dx)
  {
     core->begin(MTK_POLYGON);
     core->setVertex(x,func(x,z),z);
     core->setVertex(x,func(x,z+dz),z+dz);
     core->setVertex(x+dx,func(x+dx,z+dz),z+dz);
     core->setVertex(x+dx,func(x+dx,z),z);
     core->end();
  }
  core->finishElement();
}




void init (void)
{
  core=new mtkCoreGL();
  cid=core->createCamera();
}


int main (int argc, char *argv[])
{

  mtkxGlutWindow::mtkxGlutInitWindow(&argc,argv);

  init();

  janela = new mtkxGlutWindow(core, cid, "Senoide");

  janela->mtkxKeyboardFunc(keyboard);


  janela->mtkxMappingFunc(MapaSeno);
  janela->mtkxSetCursorType(mtkxWindow::MTKX_CURSOR_3D);

  core->cameraInitialize(cid);
  core->setCameraPosition(cid,2.5,6,10,MTK_RELATIVE);
  srand(time(NULL));
  update();

  mtkxGlutWindow::mtkxMainLoop();

  return 0;
}

  
