#include <stdio.h>
#include <math.h>
#include <time.h>

#include "gm.h"
#include "mtk.h"
#include "mtk_manip.h"
#include "../mtkx.h"
#include <GL/glu.h>

mtkCoreGL *core;
mtkCameraId cid;

gmPoint3 cubecenter, wirecenter;
gmPoint3 grabpoint;
int grabbing = 0;
int hit = 0;
GLdouble xlimit = 2, zlimit =3;

mtkxGlutWindow *janela;

double rnd(int x)
{
   return ((double)x*(double)rand()/(RAND_MAX+1.0));
}

void update ();

GLdouble func(GLdouble x, GLdouble z)
{
   return sin(z);
}

void MapaSeno(int x, int y, GLdouble *result)
{
   gmPoint3 p;
   
//   mtkxWindow::_mtkxMappingPlanes(x,y,result);

   if(result[2] == 0)
      result[2] = -result[1];

   p = core->getCursorPosition();
   result[1] = func(p[0]+result[0],p[2]+result[2])-p[1];
}

void keyboard (unsigned char key, int x, int y)
{
  // unused parameters
  x=y;

  switch (key) {
  case 27:
    exit(0);
  default:
    break;
  }
}


void update ()
{
  GLdouble z,dz, x, dx;

  core->setLightType(MTK_LIGHT0, MTK_DIRECTIONAL_LIGHT);
  core->setLightPosition(MTK_LIGHT0, gmPoint3(2.2, 4.0, 2.8));
  core->setLightComponents(MTK_LIGHT0, MTK_DIFFUSE,
                           gmPoint4(1.0, 1.0, 1.0, 1.0));
  core->setLight(MTK_LIGHT0, MTK_ACTIVE);
  core->setLighting(MTK_ACTIVE);


  core->setMaterialv(MTK_FRONT_AND_BACK,MTK_DIFFUSE,
                     gmPoint4(0.0, 1.0, 1.0, 1.0));
  core->createElement(1);
  dz = 0.2;
  dx = 4;

  for(z=-zlimit; z < zlimit; z += dz)
  for(x=-xlimit; x < xlimit; x += dx)
  {
     core->begin(MTK_POLYGON);
     core->setVertex(x,func(x,z),z);
     core->setVertex(x,func(x,z+dz),z+dz);
     core->setVertex(x+dx,func(x+dx,z+dz),z+dz);
     core->setVertex(x+dx,func(x+dx,z),z);
     core->end();
  }
  core->finishElement();
}




void init (void)
{
  core=new mtkCoreGL();
  cid=core->createCamera();
}


int main (int argc, char *argv[])
{

  mtkxGlutWindow::mtkxGlutInitWindow(&argc,argv);

  init();

  janela = new mtkxGlutWindow(core, cid, "Senoide");

  janela->mtkxKeyboardFunc(keyboard);


  //  janela->mtkxMappingFunc(MapaSeno);
  janela->mtkxSetImplicit(func);
  janela->mtkxSetMotionType(mtkxWindow::MTKX_MOTION_IMPLICIT);
  janela->mtkxSetCursorType(mtkxWindow::MTKX_CURSOR_3D);

  core->cameraInitialize(cid);
  core->setCameraPosition(cid,2.5,6,10,MTK_RELATIVE);
  srand(time(NULL));

  update();

  mtkxGlutWindow::mtkxMainLoop();

  return 0;
}

  
