// -*- mode: C++; -*-
 
/* Manipulation Toolkit Extension (MTKX)
 * Copyright (C) 2000 Leonardo A. G. Mesquita
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <X11/Xlib.h>
#include <X11/extensions/XInput.h>

#include <stdio.h>


main()
{
   Display *d;
   XExtensionVersion *version;
   XDeviceInfoPtr dev_info, dev;
   int num_dev;
   int i; 
   int a,b,c;
   char *atom;
   Window root, parent, *children;
   unsigned int nc;

   d = XOpenDisplay(NULL);
   
   version = XGetExtensionVersion(d, "XInputExtension");


   if(version == NULL || ((int) version) == NoSuchExtension)
      printf("No Version!!\n");
   else
   {
      a = XQueryExtension(d,"XInputExtension",&a,&b,&c);
      printf("%d\n",version);
      printf("%d\n",a);
   
      dev_info = XListInputDevices(d, &num_dev); 

      if(dev_info)
         for(i = 0; i < num_dev; i++)
         {
            dev = &dev_info[i];
            printf("Disp: %d Nome: %s ", i, dev->name);
            atom = XGetAtomName(d,dev->type);
            if(atom != NULL)
               printf("Atom: %s\n", atom);
         }

      XFree(version);

      XQueryTree(d, RootWindowOfScreen(DefaultScreenOfDisplay(d)), &root,
                 &parent, &children, &nc);
      for(i = 0; i < (int) nc; i++)
      {
         XFetchName(d, children[i], &atom);
         if(atom != NULL)
            printf("Win: %s\n", atom);
      }
   }
}
