// -*- mode: C++; -*-

/* Manipulation Toolkit (MTK)
 * Copyright (C) 1997-1998 Marcelo de G. Malheiros and Flavio N. Fernandes
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MAIN_H
#define MAIN_H

#if 0
class Camera {
public:
  Camera (Widget parent, int w, int h);
  ~Camera ();

  void draw ();
  void drawAll ();

protected:
  static void initCallback_ (Widget w, XtPointer client, XtPointer call);
  void init_ ();
  static void exposeCallback_ (Widget w, XtPointer client, XtPointer call);
  static void resizeCallback_ (Widget w, XtPointer client, XtPointer call);
  void resize_ (int width, int height);
  static void eventHandler_ (Widget w, XtPointer client, XEvent *event,
                             Boolean *cont);
  void event_ (Widget w, XEvent *event);

  static list<Camera *> all_;
  static GLXContext first_ctxt_;

  mtkCameraId id_;
  GLXContext ctxt_;
  Widget area_;
};
#endif

void fatal (char *msg);

void initialize ();

void translateModel (mtkManipulatorId id, list<mtkId> id_list,
                     gmVector3 v, void *data);
void scaleModel (mtkManipulatorId id, list<mtkId> id_list,
                 gmPoint3 p, gmVector3 v, double f, void *data);
void rotateModel (mtkManipulatorId id, list<mtkId> id_list,
                  gmPoint3 p, gmVector3 v, double a, void *data);
void shearModel (mtkManipulatorId id, list<mtkId> id_list,
                 gmMatrix4 m, void *data);

void createCallback ();
void cutCallback ();
void selectCallback (int action);

#if 0
void newCameraCallback (Widget w, XtPointer client, XtPointer call);
void closeCameraCallback (Widget w, XtPointer client, XtPointer call);
void quitCallback (Widget w, XtPointer client, XtPointer call);
#endif

void reshape (int width, int height);
void display ();
void mouse (int button, int state, int x, int y);
void motion (int x, int y);
void keyboard (unsigned char key, int x, int y);

enum {MENU_SEP, MENU_CREATE, MENU_CUT, MENU_SELECT_ALL, MENU_QUIT};

void menu (int value);

#endif //  MAIN_H
