// -*- mode: C++; -*-

/* Manipulation Toolkit (MTK)
 * Copyright (C) 1997-1998 Marcelo de G. Malheiros and Flavio N. Fernandes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MTK_CURSOR_H
#define MTK_CURSOR_H

#include "gm.h"
#include "mtk_general.h"


typedef unsigned int mtkCursorState;
#define MTK_CURSOR_ACTIVE   1
#define MTK_CURSOR_INACTIVE 0

class mtkCursor
{
   public:
      mtkCursor();
      virtual void draw() = 0;
      void move(gmPoint3);
      void setState(mtkCursorState);
      mtkCursorState getState();
      gmPoint3 getPosition();
   
   protected:
      mtkCursorState _state;
      gmPoint3 _position;
};

class mtkCursorGL : public mtkCursor
{
   public:
      void draw();
};


#endif
