// -*- mode: C++; -*-

/* Manipulation Toolkit (MTK)
 * Copyright (C) 1997-1998 Marcelo de G. Malheiros and Flavio N. Fernandes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MTK_GENERAL_H
#define MTK_GENERAL_H

// we need bool, so let's include a random STL header here
#include <pair.h>

/// high-level object types
typedef unsigned int mtkType;
#define MTK_NONE    0
#define MTK_ELEMENT 1
#define MTK_DRAGGER 2
#define MTK_CAMERA  3

/// valid states
enum mtkState {MTK_ACTIVE, MTK_INACTIVE, MTK_HIDDEN};

/// types of events (both pointer and 3D)
enum mtkEvent {MTK_PICK, MTK_MOVE, MTK_RELEASE};

/// types of shading available in the display list
enum mtkShadeModel {MTK_FLAT, MTK_SMOOTH};

/// identifier of display list elements
typedef unsigned int mtkId;

/// material attribute
enum mtkMaterialComponent {MTK_AMBIENT, MTK_DIFFUSE, MTK_SPECULAR,
                           MTK_SHININESS, MTK_EMISSION, MTK_POSITION};

/// color in the RGB format
typedef struct {
  float r, g, b;
} mtkColor;


#endif // MTK_GENERAL_H
