// -*- mode: C++; -*-

/* Manipulation Toolkit (MTK)
 * Copyright (C) 1997-1998 Marcelo de G. Malheiros and Flavio N. Fernandes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MTK_WRAPPER_H
#define MTK_WRAPPER_H


// based on pointer wrapper template by Mumit Khan (khan@xraylith.wisc.edu)

template <class T>
class mtkWrapper {
public:
  mtkWrapper (T *t_ptr=0) : t_ptr_(t_ptr) {}
  mtkWrapper (const mtkWrapper<T>& w) {
    t_ptr_=w()?w()->clone():0;
  }
  ~mtkWrapper () { delete t_ptr_; }

  const T *operator() () const { return t_ptr_; }
  T *operator() () { return t_ptr_; }
  mtkWrapper<T>& operator= (const mtkWrapper<T>& w) {
    delete t_ptr_;
    t_ptr_=w()->clone();
    return *this;
  }

private:
  T *t_ptr_;
};


template <class T>
bool operator== (const mtkWrapper<T>& w1, const mtkWrapper<T>& w2)
{
  return false;
}


template <class T>
bool operator< (const mtkWrapper<T>& w1, const mtkWrapper<T>& w2)
{
  return false;
}


#endif // MTK_WRAPPER_H
